<script src="@#file#(math.min.js)" type="text/javascript"></script>
<script src="@#file#(bezier.js)"   type="text/javascript"></script>

  <p>Sada ćemo još pogledati kako odrediti tangencijalni vektor u zadanoj točki krivulje (točnije, za zadanu vrijednost parametra). Tangencijalni vektor je vektor koji kada postavimo u promatranu točku određuje tangencijalni pravac: pravac koji u toj točki dodiruje (tangira) Bezierovu krivulju. Tangencijalni vektor sadrži još jednu informaciju: govori nam da ako se vrijednost parametra malo poveća, u kojem će se smjeru točka koja putuje po krivulji pomaknuti.</p>

  <p>U nastavku je dan prikaz aproksimacijske Bezierove krivulje određene s četiri točke. Kliznikom ispod demonstracije možete određivati parametar \(t\) u kojem želite da se prikaže tangencijalni vektor. Pomičite ovaj kliznik i pratite kako se mijenja tangencijalni vektor.</p>

<p>U ovom konkretnom slučaju, magnituda tangencijalnog vektora je dosta velika pa strelicu vektora ne vidite; uključite stoga opciju "Skaliraj tangencijalni vektor" koja će normu vektora podesiti na fiksnu i dovoljno malu da možete vidjeti čitav vektor. Pomičite sada kliznik.</p>

<p>Konačno, uključite prikaz tangencijalnog pravca. Uočite da taj pravac uvijek samo dodiruje krivulju u promatranoj točki.</p>

  <div style="width: 800px; height: 300px; position:relative;">
  <canvas id="myCanvas1" width="800" height="300" style="border: 1px solid black;"></canvas>
  </div>
  <script type="text/javascript">
    var bez1 = new drawInterpolationBezier("myCanvas1");
    bez1.addingEnabled = false;
    bez1.curveApprox = true;
    bez1.showTangentAtT = true;
    bez1.showTangentVectorAtT = true;
    bez1.showTangentLineAtT = false;
    bez1.scaleTangentVectorAtT = false;
    bez1.setAllPoints([[51,251],[25,27],[780,280],[600,70]]);
    bez1.paint();
  </script>
  <input type="checkbox" checked onclick="bez1.curveApprox=this.checked; bez1.paint();"> Aproksimacijska krivulja<br>
  <input type="checkbox" onclick="bez1.showTangentLineAtT=this.checked; bez1.paint();"> Prikaži tangencijalni pravac<br>
  <input type="checkbox" onclick="bez1.scaleTangentVectorAtT=this.checked; bez1.paint();"> Skaliraj tangencijalni vektor<br>
  <table>
  <tr><td align="right">0</td><td><input type="range" min="0" max="1" step="0.01" value="0" onchange="bez1.tvalue=this.value; document.getElementById('bezBuild1').innerHTML=this.value; bez1.paint();" oninput="bez1.tvalue=this.value; document.getElementById('bezBuild1').innerHTML=this.value; bez1.paint();"></td><td>1  (vrijednost t = <span id="bezBuild1">0</span>)</td></tr>
  </table>

<p>Pogledajte sada dvije specifične situacije. Postavite da je \(t=0\), odnosno pogledajmo što se događa u početnoj točki krivulje. Ako još niste, uključite i prikaz tangencijalnog pravca. Uočite da tangencijalni vektor gleda direktno prema drugoj zadanoj točki (drugoj točki kontrolnog poligona). Ovo je poznato svojstvo aproksimacijske Bezierove krivulje: u početnoj točki, tangencijalni vektor je uvijek usmjeren prema drugoj točki kontrolnog poligona.</p>

<p>Postavite potom \(t=1\) - pogledajmo što se događa u posljednjoj točki krivulje. Uočite da tangencijalni vektor leži na pravcu koji prolazi kroz predzadnju zadanu točku, ali gleda u suprotnom smjeru. Ovo je također poznato svojstvo aproksimacijske Bezierove krivulje: u posljednjoj točki krivulje, tangencijalni vektor je uvijek usmjeren suprotno od predposljednje točke kontrolnog poligona.</p>

<p>Demonstracija u nastavku prikazuje sličan razmještaj točaka kao u prethodnoj demonstraciji, samo što su točke približene, čime je magnituda tangencijalnog vektora inherentno manja, pa nema potrebe za uključivanjem skaliranja. Iskoristite kliznik ispod demonstracije i pogledajte kako se mijenja tangencijalni vektor.</p>
 
  <div style="width: 800px; height: 300px; position:relative;">
  <canvas id="myCanvas2" width="800" height="300" style="border: 1px solid black;"></canvas>
  </div>
  <script type="text/javascript">
    var bez2 = new drawInterpolationBezier("myCanvas2");
    bez2.addingEnabled = false;
    bez2.curveApprox = true;
    bez2.showTangentAtT = true;
    bez2.showTangentVectorAtT = true;
    bez2.showTangentLineAtT = false;
    bez2.scaleTangentVectorAtT = false;
    bez2.setAllPoints([[250+2.5*5.1,160+2.5*25.1],[250+2.5*2.5,160+2.5*2.7],[250+2.5*78.0,160+2.5*28.0],[250+2.5*60.0,160+2.5*7.0]]);
    bez2.paint();
  </script>
  <input type="checkbox" checked onclick="bez2.curveApprox=this.checked; bez2.paint();"> Aproksimacijska krivulja<br>
  <input type="checkbox" onclick="bez2.showTangentLineAtT=this.checked; bez2.paint();"> Prikaži tangencijalni pravac<br>
  <input type="checkbox" onclick="bez2.scaleTangentVectorAtT=this.checked; bez2.paint();"> Skaliraj tangencijalni vektor<br>
  <table>
  <tr><td align="right">0</td><td><input type="range" min="0" max="1" step="0.01" value="0" onchange="bez2.tvalue=this.value; document.getElementById('bezBuild2').innerHTML=this.value; bez2.paint();" oninput="bez2.tvalue=this.value; document.getElementById('bezBuild2').innerHTML=this.value; bez2.paint();"></td><td>1  (vrijednost t = <span id="bezBuild2">0</span>)</td></tr>
  </table>

<p>Kako možemo odrediti tangencijalni vektor? Pogledat ćemo to na primjeru kubne aproksimacijske Bezierove krivulje u 2D. Prisjetimo se, ona je određena s:
\[
\begin{align*}
p_x(t) &amp;= (1-t)^3 \cdot r_{0,x} + 3 \cdot (1-t)^2 t \cdot r_{1,x} + 3 \cdot (1-t) t^2 \cdot r_{2,x} + t^3 \cdot r_{3,x}\\
p_y(t) &amp;= (1-t)^3 \cdot r_{0,y} + 3 \cdot (1-t)^2 t \cdot r_{1,y} + 3 \cdot (1-t) t^2 \cdot r_{2,y} + t^3 \cdot r_{3,y}
\end{align*}
\]
Tangencijalni vektor dobijemo tako da se pitamo: kako se mijenjaju \(x\) i \(y\) koordinate kada se malo promijeni \(t\)? Drugim riječima, zanima nas vektor:
\[
\vec v (t) = \left[ \begin{array}{cc} \frac{d}{dt} p_x(t) &amp; \frac{d}{dt} p_y(t) \end{array} \right]
\]
Uočimo sada da deriviramo sumu oblika polinom od \(t\) puta komponenta točke. Derivacija sume je suma derivacija, pa se možemo fokusirati na derivacije polinoma. Umjesto da promatramo polinome oblika \(\binom{n}{i} \cdot t^i \cdot (1-t)^{n-i}\), poslužimo se računom koji smo već napravili razlažući taj izraz na klasični oblik \(a_n t^n + a_{n-1} t^{n-1} + \ldots + a_1 t^1 + a_0\). Za kubnu aproksimacijsku Bezierovu krivulju izračun koordinata sveli smo na izraz:
\[
  \vec p(t) = 
\left[ \begin{array}{cccc} t^3 &amp; t^2 &amp; t &amp; 1 \end{array} \right]
  \cdot
  \left[ \begin{array}{cccc} -1 &amp; 3 &amp; -3 &amp; 1 \\ 3 &amp; -6 &amp; 3 &amp; 0 \\ -3 &amp; 3 &amp; 0 &amp; 0 \\ 1 &amp; 0 &amp; 0 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cc} r_{0,x} &amp; r_{0,y} \\ r_{1,x} &amp; r_{1,y} \\ r_{2,x} &amp; r_{2,y} \\ r_{3,x} &amp; r_{3,y} \end{array} \right]
\]
gdje koeficijenti uz pripadne potencije pišu u stupcima kvadratne matrice \(\textbf{B}_3\).
</p>

<p>Prisjetimo se sada matematike. Neka je 
\[ 
 \begin{align*}
  q(t) &amp;= \left[ \begin{array}{ccccc} t^n &amp; t^{n-1} &amp; \ldots &amp; t &amp; 1 \end{array} \right] \cdot \left[ \begin{array}{c} a_n \\ a_{n-1} \\ \ldots \\ a_1 \\ a_0 \end{array} \right] \\
    &amp;= a_n t^n + a_{n-1} t^{n-1} + \ldots + a_1 t^1 + a_0 \\
 \end{align*}
\] polinom \(n\)-tog stupnja. Njegova derivacija po \(t\) tada je:
\[
 \begin{align*}
  \frac{d}{dt} q(t) &amp;= n \cdot a_n t^{n-1} + (n-1) \cdot a_{n-1} t^{n-2} + \ldots + 2 \cdot a_2 t + a_1 + 0 \\
  &amp;= \left[ \begin{array}{ccccc} n \cdot t^{n-1} &amp; (n-1) \cdot t^{n-2} &amp; \ldots &amp; 1 &amp; 0 \end{array} \right] \cdot \left[ \begin{array}{c} a_n \\ a_{n-1} \\ \ldots \\ a_1 \\ a_0 \end{array} \right]
 \end{align*}
\]
Iz ovoga pak odmah slijedi da točke bezierove krivulje dobivamo tako da vektor potencija parametra množimo matricom \(\textbf{B}_n \cdot \textbf{R}\) a tangencijalni vektor dobivamo tako da vektor derivacija potencija parametra množimo matricom \(\textbf{B}_n \cdot \textbf{R}\). Tako u slučaju kubne aproksimacijske Bezierove krivulje tangencijalni vektor računamo kao:
\[
  \vec v(t) = 
\left[ \begin{array}{cccc} 3 t^2 &amp; 2 t &amp; 1 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cccc} -1 &amp; 3 &amp; -3 &amp; 1 \\ 3 &amp; -6 &amp; 3 &amp; 0 \\ -3 &amp; 3 &amp; 0 &amp; 0 \\ 1 &amp; 0 &amp; 0 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cc} r_{0,x} &amp; r_{0,y} \\ r_{1,x} &amp; r_{1,y} \\ r_{2,x} &amp; r_{2,y} \\ r_{3,x} &amp; r_{3,y} \end{array} \right]
\]
</p>

<p>Možemo li se sada uvjeriti da je naše zapažanje o smjeru tangencijalnog vektora u početnoj i konačnoj točki krivulje potvrđeno? Uvrstimo najprije da je \(t=0\). Imamo:
\[
\begin{align*}
  \vec v(t) &amp;= 
\left[ \begin{array}{cccc} 3 \cdot 0^2 &amp; 2 \cdot 0 &amp; 1 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cccc} -1 &amp; 3 &amp; -3 &amp; 1 \\ 3 &amp; -6 &amp; 3 &amp; 0 \\ -3 &amp; 3 &amp; 0 &amp; 0 \\ 1 &amp; 0 &amp; 0 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cc} r_{0,x} &amp; r_{0,y} \\ r_{1,x} &amp; r_{1,y} \\ r_{2,x} &amp; r_{2,y} \\ r_{3,x} &amp; r_{3,y} \end{array} \right] \\
  &amp;= 
\left[ \begin{array}{cccc} 0 &amp; 0 &amp; 1 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cccc} -1 &amp; 3 &amp; -3 &amp; 1 \\ 3 &amp; -6 &amp; 3 &amp; 0 \\ -3 &amp; 3 &amp; 0 &amp; 0 \\ 1 &amp; 0 &amp; 0 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cc} r_{0,x} &amp; r_{0,y} \\ r_{1,x} &amp; r_{1,y} \\ r_{2,x} &amp; r_{2,y} \\ r_{3,x} &amp; r_{3,y} \end{array} \right] \\
  &amp;= 
\left[ \begin{array}{cccc} -3 &amp; 3 &amp; 0 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cc} r_{0,x} &amp; r_{0,y} \\ r_{1,x} &amp; r_{1,y} \\ r_{2,x} &amp; r_{2,y} \\ r_{3,x} &amp; r_{3,y} \end{array} \right] \\
  &amp;= 
\left[ \begin{array}{cc} -3 r_{0,x} + 3 r_{1,x} &amp; -3 r_{0,y} + 3 r_{1,y} \end{array} \right] \\
  &amp;= 3 \cdot (\vec r_1 - \vec r_0)
\end{align*}
\]
I doista, tangencijalni vektor iz \(\vec r_0\) gleda izravno prema \(\vec r_1\), a magnituda mu je trostruka udaljenost točaka \(\vec r_0\) i \(\vec r_1\). Ovo lijepo možete vidjeti na drugoj demonstraciji: uporabom kliznika podesite da je \(t=0\) - pogledajte još jednom smjer vektora te sada usporedite njegovu magnitudu (normu) i udaljenost točaka \(\vec r_0\) i \(\vec r_1\) (ako ste imali uključeno skaliranje, isključite ga).
</p>

<p>
Provjerimo sada kakva je situacija na drugom kraju krivulje: neka je \(t=1\). Računamo:
\[
\begin{align*}
  \vec v(t) &amp;= 
\left[ \begin{array}{cccc} 3 \cdot 1^2 &amp; 2 \cdot 1 &amp; 1 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cccc} -1 &amp; 3 &amp; -3 &amp; 1 \\ 3 &amp; -6 &amp; 3 &amp; 0 \\ -3 &amp; 3 &amp; 0 &amp; 0 \\ 1 &amp; 0 &amp; 0 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cc} r_{0,x} &amp; r_{0,y} \\ r_{1,x} &amp; r_{1,y} \\ r_{2,x} &amp; r_{2,y} \\ r_{3,x} &amp; r_{3,y} \end{array} \right] \\
  &amp;= 
\left[ \begin{array}{cccc} 3 &amp; 2 &amp; 1 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cccc} -1 &amp; 3 &amp; -3 &amp; 1 \\ 3 &amp; -6 &amp; 3 &amp; 0 \\ -3 &amp; 3 &amp; 0 &amp; 0 \\ 1 &amp; 0 &amp; 0 &amp; 0 \end{array} \right]
  \cdot
  \left[ \begin{array}{cc} r_{0,x} &amp; r_{0,y} \\ r_{1,x} &amp; r_{1,y} \\ r_{2,x} &amp; r_{2,y} \\ r_{3,x} &amp; r_{3,y} \end{array} \right] \\
  &amp;= 
\left[ \begin{array}{cccc} 0 &amp; 0 &amp; -3 &amp; 3 \end{array} \right]
  \cdot
  \left[ \begin{array}{cc} r_{0,x} &amp; r_{0,y} \\ r_{1,x} &amp; r_{1,y} \\ r_{2,x} &amp; r_{2,y} \\ r_{3,x} &amp; r_{3,y} \end{array} \right] \\
  &amp;= 
\left[ \begin{array}{cc} -3 r_{2,x} + 3 r_{3,x} &amp; -3 r_{2,y} + 3 r_{3,y} \end{array} \right] \\
  &amp;= 3 \cdot (\vec r_3 - \vec r_2)
\end{align*}
\]
čime smo opet potvrdili: u posljednjoj točki, vektor je smjera kao da iz predposljednje točke gleda u posljednju. Norma mu je jednaka trostrukoj udaljenosti predzadnje i zadnje točke kontrolnog poligona. Ovo skaliranje norme je razlog što vrh tangencijalnog vektora nismo mogli vidjeti na prvoj demonstraciji. Uočite također da ne smijete zapamtiti da je općenito u početnoj i konačnoj točki krivulje norma tangencijalnog vektora jednaka trostrukoj udaljenosti spomenutih točaka - koeficijent s kojim se ta udaljenost množi dolazi iz matrice \(\textbf{B}_n\) i za krivulje različitih stupnjeva bit će različit.
</p>

